#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <zlib.h>
 
 
int joylink_gzip_compress(const char *src, int srcLen, char *dst, int dstLen)
{
	z_stream strm;
	//初始化strm结构中的zalloc, zfree, opaque,要求使用默认的内存分配策略
	strm.zalloc = Z_NULL;
	strm.zfree = Z_NULL;
	strm.opaque = Z_NULL;
 
	//设置输入输出缓冲区
	strm.avail_in = srcLen;
	strm.avail_out = dstLen;
	strm.next_in = (Bytef *)src;
	strm.next_out = (Bytef *)dst;
 
	int err = -1;
	//初始化zlib的状态，成功返回Z_OK
	//deflateInit:zlib格式，deflateInit2:gzip格式
	//     err = deflateInit(&strm, Z_DEFAULT_COMPRESSION);
	err = deflateInit2(&strm, Z_DEFAULT_COMPRESSION, Z_DEFLATED, MAX_WBITS + 16, MAX_MEM_LEVEL, Z_DEFAULT_STRATEGY);
	if (err == Z_OK)
	{
		//Z_FINISH表明完成输入，让deflate()完成输出
		err = deflate(&strm, Z_FINISH);
		//Z_STREAM_END表明所有的输入都已经读完，所有的输出也都产生
		if (err == Z_STREAM_END)
		{
			//deflateEnd释放资源，防止内存泄漏
			(void)deflateEnd(&strm);
			 printf("compression succed, before compression size is %d, after compressione size is %d\n" ,strm.total_in ,dstLen - strm.avail_out);
			//strm.avail_out表明输出缓冲区剩余的空闲空间大小
			return dstLen - strm.avail_out;
		}
		else
		{
			(void)deflateEnd(&strm);
			printf("compression failed, deflate return: !\n");
			return -1;
		}
	}
	else
	{
		(void)deflateEnd(&strm);
		printf("compression initialization failed, quit!\n");
		return 0;
	}
}
 
int joylink_gzip_decompress(const char *src, int srcLen, char *dst, int dstLen)
{
	z_stream strm;
	strm.zalloc = NULL;
	strm.zfree = NULL;
	strm.opaque = NULL;
 
	strm.avail_in = srcLen;
	strm.avail_out = dstLen;
	strm.next_in = (Bytef *)src;
	strm.next_out = (Bytef *)dst;
 
	int err = -1;
	err = inflateInit2(&strm, MAX_WBITS + 16);
	//err = inflateInit(&strm);
	if (err == Z_OK)
	{
		err = inflate(&strm, Z_FINISH);
		if (err == Z_STREAM_END)
		{
			(void)inflateEnd(&strm);
			printf("decompress succed, before decompress size is %d, after decompress size is %d\n", strm.total_in, dstLen - strm.avail_out);
			return strm.total_out;
		}
		else
		{
			(void)inflateEnd(&strm);
			printf("decompression failed, inflate return: \n");
			return -1;
		}
	}
	else
	{
		inflateEnd(&strm);
		printf("decompression initialization failed, quit!\n");
		return 0;
	}
}

